# class KURLRequester | A widget to request a filename/url from the user. More...
Definition | `#include <kurlrequester.h>`
Inherits | QHBox (qt) [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Methods

- KURLRequester ( QWidget *parent=0, const char *name=0, bool modal = true )
- KURLRequester ( const QString& url, QWidget *parent=0, const char *name=0, bool modal = true )
- KURLRequester ( QWidget *editWidget, QWidget *parent, const char *name=0, bool modal = true )
- ~KURLRequester ()
- QString url () const
- void setShowLocalProtocol ( bool b )
- bool showLocalProtocol () const
- virtual KFileDialog * fileDialog () const
- KLineEdit * lineEdit () const
- KComboBox * comboBox () const
- QPushButton * button () const
- KURLCompletion * completionObject () const

#### Public Slots

- void setURL (const QString& url)
- void clear ()

#### Signals

- void textChanged (const QString&)
- void returnPressed ()
- void returnPressed ( const QString& )
- void openFileDialog ( KURLRequester * )

#### Protected Methods

- void init ()

#### Protected Slots

- void slotOpenDialog ()

#### Protected Members

- KLineEdit * myEdit
- QPushButton * myButton
- KURLCompletion * myCompletion
- bool myModal

## Detailed Description

This class is a widget showing a lineedit and a button, which invokes a filedialog. File completion is available in the lineedit.

The defaults for the filedialog are to ask for one existing local file, i.e. KFileDialog::setMode( KFile::File | KFile::ExistingOnly | KFile::LocalOnly ) The default filter is "*", i.e. show all files, and the start directory is the current working directory, or the last directory where a file has been selected.

You can change this behavior by obtaining a pointer to the dialog (fileDialog()) and calling the appropriate methods.

KURLRequester ( QWidget *parent=0, const char *name=0, bool modal = true ) | ### KURLRequester

Constructs a KURLRequester widget

Parameters:

modal | specifies whether the filedialog should be opened as modal or not.

KURLRequester ( const QString& url, QWidget *parent=0, const char *name=0, bool modal = true ) | ### KURLRequester

Constructs a KURLRequester widget with the default URL `url`

Parameters:

modal | specifies whether the filedialog should be opened as modal or not.

KURLRequester ( QWidget *editWidget, QWidget *parent, const char *name=0, bool modal = true ) | ### KURLRequester

Special constructor, which creates a KURLRequester widget with a custom edit-widget. The edit-widget can be either a KComboBox or a KLineEdit (or inherited thereof). Note: for geometry management reasons, the edit-widget is reparented to have the KURLRequester as parent.

Parameters:

modal | specifies whether the filedialog should be opened as modal or not.

~KURLRequester () | ### ~KURLRequester

Destructs the KURLRequester

QString url () | ### url

[const]

Returns: the current url in the lineedit. May be malformed, if the user entered something weird.

void setShowLocalProtocol ( bool b ) | ### setShowLocalProtocol

Enables/disables showing file:/ in the lineedit, when a local file has been selected in the filedialog or was set via setURL(). Default is false, not showing file:/

See also: showLocalProtocol

bool showLocalProtocol () | ### showLocalProtocol

[const]

Returns: whether local files will be prefixed with file:/ in the lineedit

See also: setShowLocalProtocol

KFileDialog * fileDialog () | ### fileDialog

[const virtual]

Returns: a pointer to the filedialog You can use this to customize the dialog, e.g. to specify a filter. Never returns 0L.

KLineEdit * lineEdit () | ### lineEdit

[const]

It is provided so that you can e.g. set an own completion object (e.g. KShellCompletion) into it.

Returns: a pointer to the lineedit, either the default one, or the special one, if you used the special constructor.

KComboBox * comboBox () | ### comboBox

[const]

Returns: a pointer to the combobox, in case you have set one using the special constructor. Returns 0L otherwise.

QPushButton * button () | ### button

[const]

Returns: a pointer to the pushbutton. It is provided so that you can specify an own pixmap or a text, if you really need to.

KURLCompletion * completionObject () | ### completionObject

[const]

Returns: the KURLCompletion object used in the lineedit/combobox.

void setURL (const QString& url) | ### setURL

[slot]

Sets the url in the lineedit to `url`. Depending on the state of showLocalProtocol(), file:/ on local files will be shown or not.

void clear () | ### clear

[slot]

Clears the lineedit/combobox.

void textChanged (const QString&) | ### textChanged

[signal]

Emitted when the text in the lineedit changes. The parameter contains the contents of the lineedit.

void returnPressed () | ### returnPressed

[signal]

Emitted when return or enter was pressed in the lineedit.

void returnPressed ( const QString& ) | ### returnPressed

[signal]

Emitted when return or enter was pressed in the lineedit. The parameter contains the contents of the lineedit.

void openFileDialog ( KURLRequester * ) | ### openFileDialog

[signal]

Emitted before the filedialog is going to open. Connect to this signal to "configure" the filedialog, e.g. set the filefilter, the mode, a preview-widget, etc. It's usually not necessary to set a URL for the filedialog, as it will get set properly from the editfield contents.

If you use multiple KURLRequesters, you can connect all of them to the same slot and use the given KURLRequester pointer to know which one is going to open.

void init () | ### init

[protected]

KLineEdit * myEdit | ### myEdit

[protected]

QPushButton * myButton | ### myButton

[protected]

KURLCompletion * myCompletion | ### myCompletion

[protected]

bool myModal | ### myModal

[protected]

void slotOpenDialog () | ### slotOpenDialog

[protected slots slot]

Called when the button is pressed to open the filedialog. Also called when KStdAccel::Open (default is Ctrl-O) is pressed.

- Author: Carsten Pfeiffer <pfeiffer@kde.org>
- Generated: root@sparc.ports.openbsd.org on Wed May 2 09:42:26 2001, using kdoc 2.0a53.